"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.text = exports.peek = exports.char = exports.optionalSpaces = exports.escapedSlash = exports.escapedCloseMustache = exports.escapedOpenMustache = exports.closeMustache = exports.openMustache = exports.atPos = exports.join = void 0;
const pierrejs_1 = require("pierrejs");
const join = (arr) => arr.join('');
exports.join = join;
const atPos = (pos) => (arr) => arr[pos];
exports.atPos = atPos;
exports.openMustache = pierrejs_1.default.string('{{');
exports.closeMustache = pierrejs_1.default.string('}}');
exports.escapedOpenMustache = pierrejs_1.default.string('\\{{').map(() => '{{');
exports.escapedCloseMustache = pierrejs_1.default.string('\\}}').map(() => '}}');
exports.escapedSlash = pierrejs_1.default.string('\\\\').map(() => '\\');
exports.optionalSpaces = pierrejs_1.default.optional(pierrejs_1.default.spaces());
exports.char = pierrejs_1.default.regex('char', /^./);
exports.peek = pierrejs_1.default.lookAhead(exports.char);
exports.text = pierrejs_1.default.oneOrMany(pierrejs_1.default.either(exports.escapedSlash, exports.escapedOpenMustache, exports.escapedCloseMustache, pierrejs_1.default.except(pierrejs_1.default.oneOf(exports.closeMustache, exports.openMustache)))).map(exports.join);
